/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: IAuditConsoleDelegate.as 19356 2010-03-04 21:02:36Z mancelin $
 * --------------------------------------------------------------------------
 */
package org.ow2.jonas.admin.auditconsole.business {
import org.ow2.jasmine.kerneos.common.business.IDelegateResponder;

public interface IAuditConsoleDelegate extends IDelegateResponder {
    /**
     * Call the java side method for getting audit reports.
     */
    function getReportObjects() : void;
    /**
     * Call the java side method for starting auditing service
     */
    function startAuditing() : void;
    /**
     * Call the java side method for stopping auditing service.
     */
    function stopAuditing() : void;
    /**
     * Call the java side method for starting listening to audit notifications.
     */
    function startListening() : void;
    /**
     * Call the java side method for stopping listening to audit notifications.
     */
    function unregister() : void;

	/**
	 * Call the java side method for getting Tree Nodes ID.
	 */
	function getTreeNodesID(keyword:String, maxResults:Number, depth:Number) : void;

	/**
	 * Get the graph for the given node ID.
	 */
	function getGraphNodeID(id: String) : void;
}
}
