/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: AuditConsoleTreeBranchVO.as 19356 2010-03-04 21:02:36Z mancelin $
 * --------------------------------------------------------------------------
 */

package org.ow2.jonas.admin.auditconsole.vo {

import mx.collections.ArrayCollection;
import mx.controls.Alert;

/**
 * Generic tree branch.
 */
public class AuditConsoleTreeBranchVO {

    private var branchIconAtt:String;

    private var branchLabelAtt:String = "";

    private var branchTargetAtt:String = "";

    private var branchAtt:XML = null;

    private var branchBeansAtt:ArrayCollection = null;
    /**
     * Constructor.
     */
    public function AuditConsoleTreeBranchVO(label:String, icon:String, target:String) {
        branchLabelAtt = label;
        branchTargetAtt = target;
        branchIconAtt = icon;
        branchAtt = <node></node>;
        branchAtt.@label = branchLabelAtt;
        branchAtt.@icon = branchIconAtt;
        branchAtt.@target = branchTargetAtt;
        branchBeansAtt = new ArrayCollection();
    }

    public function get branchIcon():String {
        return branchIconAtt;
    }

    public function set branchIcon(value:String):void {
        branchIconAtt = value;
    }

    public function get branchLabel():String {
        return branchLabelAtt;
    }

    public function set branchLabel(value:String):void {
        branchLabelAtt = value;
    }

    public function get branchTarget():String {
        return branchTargetAtt;
    }

    public function set branchTarget(value:String):void {
        branchTargetAtt = value;
    }

    public function get branch():XML {
        return branchAtt;
    }

    public function set branch(value:XML):void {
        branchAtt = value;
    }

    private function mergeBranches(added:String):void {
        var exists:Boolean = false;
        var beansNames:Array = added.split("/");
        var tmpBranchAtt:XML = this.branchAtt;
        var path:String = branchTargetAtt + "/";
        if (beansNames.length > 0) {
            for (var i:int = 0; i < beansNames.length; i ++) {
                path = path.concat(beansNames[i]);
                if (beansNames[i] != "") {
                    for each(var node:XML in tmpBranchAtt.children()) {
                        if (node.@label == beansNames[i]) {
                            exists = true;
                            tmpBranchAtt = node;
                            break;
                        }
                    }
                    if (!exists) {
                        var newChild:XML = <node label="virgin" icon="beanIcon" target="/JOnAS/EasyBeans"></node>;
                        newChild.@label =  beansNames[i];
                        newChild.@target = path;
                        newChild.@icon = branchIconAtt;
                        tmpBranchAtt.appendChild(newChild);
                        tmpBranchAtt = newChild;
                    }
                    exists = false;
                    path = path.concat("/");
                }
            }
        }
    }

    public function addBean(bean:String):void {
        if (!branchBeansAtt.contains(bean)) {
            branchBeansAtt.addItem(bean);
            mergeBranches(bean);
        }
    }
}
}