/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: GenericAuditReportVO.as 19356 2010-03-04 21:02:36Z mancelin $
 * --------------------------------------------------------------------------
 */

package org.ow2.jonas.admin.auditconsole.vo {
import com.adobe.cairngorm.vo.IValueObject;

import flash.errors.IllegalOperationError;

import mx.collections.ArrayCollection;
import mx.formatters.DateFormatter;

/**
 * Object that represent a generic audit report.
 */
[RemoteClass(alias="org.ow2.util.auditreport.impl.GenericAuditReport")]
[Bindable]
public class GenericAuditReportVO extends BasicAuditReportVO implements IValueObject {

    [Embed("/../assets/jonas-icone.png")]
    public const jonasIcon:Class;

    public var beanName:String = "";

    public var roles:String = "";

    public var user:String = "";

    public var reportID:Number = 0;

    public var parentID:Number = 0;

    public var freeMemoryBefore:Number = 0;

    public var totalMemoryBefore:Number = 0;

    public var freeMemoryAfter :Number = 0;

    public var totalMemoryAfter:Number = 0;

    public var sweepMarkTime:Number = 0;

    public var scavengeTime:Number = 0;

    public var callLevel:int = 0;

	public var methodStackTrace:Array = null;
    /**
     * Constructor.
     */
    public function GenericAuditReportVO() {
        super();
    }

    public override function toString():String {
        var ret:String = "Audit report data : " +
            super.toHTMLString() +
            " ID : " + reportID +
            " parent ID := " + parentID +
            " Roles : " + roles +
            " User : " + user +
            " Call level : " + callLevel +
            " Memory free before : " + freeMemoryBefore + " bytes" +
            " Memory free after : " + freeMemoryAfter + " bytes" +
            " Memory total before : " + totalMemoryBefore + " bytes>" +
            " Memory total after : " + totalMemoryAfter + " bytes>" +
            " Garbage collection occurences : " + sweepMarkTime + " times" +
            " Garbage collection total duration : " + scavengeTime + " ms";
            return ret;
    }

    
    public override function toHTMLString():String {
        var ret:String = "<font size=\"22\">Audit report data </font>: <br/><br/>" +
            super.toHTMLString() +
            "<font color=\"#FF0000\"><b>ID</b></font> : " + reportID + "<br/>" +
            "<font color=\"#FF0000\"><b>parent ID</b></font> : " + parentID + "<br/>" +
            "<font color=\"#FF0000\"><b>Roles</b></font> : " + roles + "<br/>" +
            "<font color=\"#FF0000\"><b>User</b></font> : " + user + "<br/>" +
            "<font color=\"#FF0000\"><b>Call level</b></font> : " + callLevel + "<br/>" +
            "<font color=\"#FF0000\"><b>Memory free before</b></font> : " + freeMemoryBefore + " bytes<br/>" +
            "<font color=\"#FF0000\"><b>Memory free after</b></font> : " + freeMemoryAfter + " bytes<br/>" +
            "<font color=\"#FF0000\"><b>Memory total before</b></font> : " + totalMemoryBefore + " bytes<br/>" +
            "<font color=\"#FF0000\"><b>Memory total after</b></font> : " + totalMemoryAfter + " bytes<br/>" +
            "<font color=\"#FF0000\"><b>Garbage collection occurences</b></font> : " + sweepMarkTime + " times<br/>" +
            "<font color=\"#FF0000\"><b>Garbage collection total duration</b></font> : " + scavengeTime + " ms<br/>";
            return ret;
    }

    public function get type():String {
        throw new IllegalOperationError ("This method is abstract and must be overrided in sub-class.");
    }

    public function get duration():Number {
        throw new IllegalOperationError ("This method is abstract and must be overrided in sub-class.");
    }

    public function isEJBInvocation():Boolean {
        throw new IllegalOperationError ("This method is abstract and must be overrided in sub-class.");
    }

    public function isWEBInvocation():Boolean {
        throw new IllegalOperationError ("This method is abstract and must be overrided in sub-class.");
    }

    public function isJNDIInvocation():Boolean {
        throw new IllegalOperationError ("This method is abstract and must be overrided in sub-class.");
    }

    public function get icon():String {
        throw new IllegalOperationError ("This method is abstract and must be overrided in sub-class.");
    }

    public function get iconClass():Class {
        throw new IllegalOperationError ("This method is abstract and must be overrided in sub-class.");
    }

    public function get gridTarget():String {
        throw new IllegalOperationError ("This method is abstract and must be overrided in sub-class.");
    }
}
}